variables:
  REPO_URL: 'packages.opentap.io'
  DOCKER_REGISTRY: 'registry.gitlab.com'
  PLUGIN: 'Yardstick'
#----------------------------------------------------------------------------------------------------------------------

stages:
  - docs
  - build
  - tests
  - publish
  - stage
#----------------------------------------------------------------------------------------------------------------------

#############################################
# Stage: docs                               #
#############################################
Documentation:
  stage: docs
  image: $DOCKER_REGISTRY/opentap/buildrunners/documentationgeneration:latest
  tags: [docker,gce]
  script:
    - tap generate-chm "Documentation/Help/Readme.md" --out "$PLUGIN/Help.chm" --title "OpenTAP $PLUGIN Package Help" --startpage "Documentation/Help/Welcome/Readme.md"
  artifacts:
    expire_in: 1 week
    paths:
      - $PLUGIN/*.chm
#----------------------------------------------------------------------------------------------------------------------

#############################################
# Stage: build                              #
#############################################
Build:
  stage: build
  image: opentapio/opentap:9.7-ubuntu18.04
  tags: [docker,gce]
  script:
    - dotnet --list-sdks
    - dotnet publish -c Release
    - export WORKSPACE_DIR=$(pwd)
    - cd $TAP_PATH
    - tap package create --project-directory $WORKSPACE_DIR $WORKSPACE_DIR/OpenTap.Plugins.$PLUGIN/package.xml
    - cd $WORKSPACE_DIR
    - mkdir bin/
    - mv $TAP_PATH/$PLUGIN*.TapPackage bin/$PLUGIN.TapPackage
  artifacts:
    expire_in: 1 day
    paths:
       - bin/
#----------------------------------------------------------------------------------------------------------------------  

#############################################
# Stage: tests                              #
#############################################
Tests:
  stage: tests
  image: opentapio/opentap:9.7-ubuntu18.04
  tags: [docker,gce]
  dependencies:
    - Build
  script:
    - dotnet restore
    - dotnet publish -o ../bin
    - dotnet vstest bin/OpenTap.Plugins.$PLUGIN.UnitTests.dll
#----------------------------------------------------------------------------------------------------------------------

#############################################
# Stage: publish                            #
#############################################
AutoPublish:
  stage: publish
  image: opentapio/opentap:9.7-slim-ubuntu18.04
  tags: [docker,gce]
  only:
    - master
    - release
  dependencies:
    - Build
    - Tests
  script:
    - tap package install PackagePublish
    - tap package publish -k $REPO_PUBLISH_KEY -r $REPO_URL bin/$PLUGIN*.TapPackage
#----------------------------------------------------------------------------------------------------------------------
